/*
 *  t01.cpp
 *  
 *
 *  Created by luke on 11/17/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include <GLUT/glut.h>
#include "time.h"
#include "math.h"
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include "rtaudio.h"
#include "math.h"
#include "chuck_fft.h"
#include "thread.h"
//#include "util_sndfile.h"
//#include "sndfile.h"
#include <sndfile.h>
#include "Zhong.h"


using namespace std;




// Globals etc---------------------------------
Wav_Buf * wav1 = NULL;
Wav_Buf * wav2 = NULL;
Wav_Buf * wav3 = NULL;
Wav_Buf * wav4 = NULL;

unsigned long time_ctr = 0;
unsigned long beat_ctr = 0;
//unsigned long eight_bars = 682839;
unsigned long eight_bars = 170170;
float		beat = 42677.5;
//float		beat = 21338.75;
int beat_state = 0;

// audio files
SNDFILE* wavfp1 = NULL;
SNDFILE* wavfp2 = NULL;
SNDFILE* wavfp3 = NULL;
SNDFILE* wavfp4 = NULL;

SF_INFO wav_info;
SF_INFO wav_info2;
SF_INFO wav_info3;
SF_INFO wav_info4;


GLfloat g_ylim = 1.0;
GLfloat g_xlim = 1.0;

GLfloat g_green_y;
GLfloat g_spec_cent;
GLuint texture[1];

// light 0 position
GLfloat g_light0_pos[4] = { 2.0f, 8.2f, 4.0f, 1.0f };

// light 1 parameters
GLfloat g_light1_ambient[] = { .2f, .2f, .2f, 1.0f };
GLfloat g_light1_diffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat g_light1_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat g_light1_pos[4] = { -2.0f, 0.0f, -4.0f, 1.0f };

// audio globals
RtAudio rtA;
SAMPLE * g_buffy = NULL;
SAMPLE * g_buffy_work = NULL;
SAMPLE ** g_vis_buff = NULL;
int g_current_vis_buff = 0;
int g_fft_size;
clock_t cur_time;
clock_t prev_time;
unsigned int g_bufferFrames;
unsigned int g_zero_crossings;
bool g_outOnOff = 0;
bool g_pause = 0;
bool g_extras = 0;

// graphics objects
Edge * left_edge;
Edge * right_edge;
Edge * bottom_edge;
Edge * top_edge;
Ball * puck;
Ball * paddle;

Mutex g_mutex;

enum zero_states {
	up,
	down,
};

//-----------------------------------------------------------------------------
// function prototypes
//-----------------------------------------------------------------------------
void idleFunc( );
void displayFunc( );
void reshapeFunc( GLsizei width, GLsizei height );
void keyboardFunc( unsigned char, int, int );
//void mouseFunc( int button, int state, int x, int y );
void initialize( );
void cleanUp( );
unsigned long next_power_2( unsigned long n );
void drawLine(GLfloat ypos, int buf_num, GLfloat zpos);
void drawPoly(GLfloat ypos, int buf_num, GLfloat zpos);
void printInputOptions();
	

//----------------------------------------------------------------------------
// audioGen: callback fcn
//----------------------------------------------------------------------------
int audioGen( void *outBuf, void *inputBuf, unsigned int numFrames, 
			 double streamTime, RtAudioStreamStatus status, void *usrData )
{
	SAMPLE *buffy = (SAMPLE *)outBuf;
	SAMPLE *inny = (SAMPLE *)inputBuf;
	SAMPLE tempSL, tempSR;
	unsigned int zrcr = 0;
	zero_states Sst;
	zero_states Lst = up;
	zero_states Rst = down;
	
	if( status )
		cerr << "Stream Underflow!" << endl;
	
	for( int i = 0; i < numFrames; i++)
	{
		tempSL = (*inny++);
		tempSR = (*inny++);
		
		// Input: analysis
		// count zero crossings
		Sst = (tempSL > 0) ? up : down;
		if( Sst != Lst )
			zrcr++;
		Lst = Sst;
		Sst = (tempSR > 0) ? up : down;
		if( Sst != Rst )
			zrcr++;
		Rst = Sst;
		g_buffy_work[i] = 0.5*(tempSL + tempSR);
		
		// Ooutput: mix buffers
		tempSL = tempSR = 0.0;

		if( wav1->states[beat_state])
		{
			tempSL += wav1->getNext();
			tempSR += wav1->getNext();	
		}
		if( wav2->states[beat_state])
		{
			tempSL += wav2->getNext();
			tempSR += wav2->getNext();
		}
//		tempSL += wav3->getNext();
//		tempSR += wav3->getNext();		
//		tempSL += wav4->getNext();
//		tempSR += wav4->getNext();
		
		*buffy++ = OUT_LEVEL * tempSL;
		*buffy++ = OUT_LEVEL * tempSR;
		
		// keep track of time
		time_ctr++;
		beat_ctr++;
		
		if (beat_ctr >= beat)
		{
			beat_ctr = 0;
			beat_state++;
			beat_state = (beat_state > 3) ? 0 : beat_state;
			cout << "beat = "<<beat_state<<endl;
		}
		
		if (time_ctr > eight_bars)
		{
			time_ctr = 0;
			beat_ctr = 0;
			wav1->setZero();
			wav2->setZero();			
			wav3->setZero();
			wav4->setZero();
		}



			

		
	}

	g_zero_crossings = zrcr;
	// cout << " zeros = " << zrcr << endl;
	
	g_mutex.lock();
	memcpy( g_buffy, g_buffy_work, sizeof(SAMPLE)*numFrames);
	g_mutex.unlock();	
	return 0;
}

	
int main( int argc, char ** argv )
{
    // Graphics Init ===============
	// initialize GLUT
    glutInit( &argc, argv );
    // double buffer, use rgb color, enable depth buffer
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
    // initialize the window size
    glutInitWindowSize( g_width, g_height );
    // set the window postion
    glutInitWindowPosition( 100, 100 );
    // create the window
    glutCreateWindow( "hw3" );
	
    // set the idle function - called when idle
    glutIdleFunc( idleFunc );
    // set the display function - called when redrawing
    glutDisplayFunc( displayFunc );
    // set the reshape function - called when client area changes
    glutReshapeFunc( reshapeFunc );
    // set the keyboard function - called on keyboard events
    glutKeyboardFunc( keyboardFunc );
    // set the mouse function - called on mouse stuff
    //glutMouseFunc( mouseFunc );
	
    // do our own initialization
    initialize();
	printInputOptions();

    // let GLUT handle the current thread from here
    glutMainLoop();
    return 0;
}

//-----------------------------------------------------------------------------
// Name: reshapeFunc( )
// Desc: called when window size changes
//-----------------------------------------------------------------------------
void reshapeFunc( GLsizei w, GLsizei h )
{
    // save the new window size
    g_width = w; g_height = h;
    // map the view port to the client area
    glViewport( 0, 0, w, h );
    // set the matrix mode to project
    glMatrixMode( GL_PROJECTION );
    // load the identity matrix
    glLoadIdentity( );
    
	// create the viewing frustum
    //gluPerspective( 45.0, (GLfloat) w / (GLfloat) h, 1.0, 300.0 );
	glOrtho(-2.0, 2.0, -2.0, 2.0, 50, -50);

	// set the matrix mode to modelview
    glMatrixMode( GL_MODELVIEW );
    // load the identity matrix
    glLoadIdentity( );
    // position the view point
    gluLookAt( 0.0f, 0.0f, 5.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f );
}

//-----------------------------------------------------------------------------
// Name: fftCalc( )
// Desc: calc fft and move into visual buffer
//-----------------------------------------------------------------------------

 void fftCalc()
{
	complex * F;
	float dBval, randval;

	// copy data into viz buffer
	cur_time = clock();
	if( (cur_time - prev_time > 70000) && !g_pause )
	{
		prev_time = cur_time;
		g_green_y = g_zero_crossings;
		
		g_mutex.lock();
		rfft( g_buffy, g_fft_size/2, FFT_FORWARD );
		F = (complex *)g_buffy;
		
		// add little noise to the "side bands" of the visual display
		for(int i = 0; i < NUM_VIZ_SIDES; i++)
		{
			randval = ( rand()%100 )/ 100.0;
			randval = (randval > 0.3) ? (randval*0.01) : 0.0;
			g_vis_buff[g_current_vis_buff][i]= g_vis_buff[g_current_vis_buff][2*NUM_VIZ_SIDES+g_fft_size/2 -i] = randval;	// add some noise here
		}
		
		// used for calculating spectral centroid
		float n_sum = 0;
		float d_sum = 0;
		for(int i = 0; i < g_fft_size/2; i++)
		{
			dBval = cmp_abs( F[i] );
		
			// spectral centroid stuff
			n_sum += (i+1) * dBval;
			d_sum += dBval;
				
			// dB with a floor
			dBval = 20*log10( dBval );
			randval = ( rand()%100 )/ 100.0;
			randval = (randval > 0.3) ? (randval*2.0) : 0.0;
			dBval = (dBval < -100.0) ? -100.0 + randval : dBval;
			g_vis_buff[g_current_vis_buff][i+NUM_VIZ_SIDES] = 0.2*(dBval + 100)/70.0;				
		}
		
		g_spec_cent = n_sum / d_sum;
		g_mutex.unlock();
		
		// low-pass-filter visual buffer
		for( int i = 1; i < 2*NUM_VIZ_SIDES + g_fft_size/2 - 1; i++)
		{
			g_vis_buff[g_current_vis_buff][i] = 0.25*g_vis_buff[g_current_vis_buff][i-1] +
												0.5*g_vis_buff[g_current_vis_buff][i] +
												0.25*g_vis_buff[g_current_vis_buff][i+1];
		}
	
		g_current_vis_buff -= 1;
		g_current_vis_buff = (g_current_vis_buff < 0) ? g_current_vis_buff + NUM_VIZ_BUFS : g_current_vis_buff;
	}
}



//-----------------------------------------------------------------------------
// Name: displayFunc( )
// Desc: callback function invoked to draw the client area
//-----------------------------------------------------------------------------
void displayFunc( )
{
	// calculate all the physics
	double time_now = clock()/(double)CLOCKS_PER_SEC;
	double time_delt = time_now - g_last_time;
	g_last_time = time_now;
	
	puck->tick(time_delt);
	paddle->tick(time_delt);
	
	
	// clear the color and depth buffers
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT ); 
	
	// draw edges
	left_edge->draw();
	right_edge->draw();
	bottom_edge->draw();
	top_edge->draw();
	
	// draw puck and paddle
	puck->draw();
	paddle->draw();
	
	
	
    // flush!
    glFlush( );
    // swap the double buffer
    glutSwapBuffers( );
}

//-----------------------------------------------------------------------------
// Name: drawLine()
// Desc: callback from GLUT
//-----------------------------------------------------------------------------
void drawLine(GLfloat ypos, int buf_num, GLfloat zpos)
{
	glPushMatrix();
	glLineWidth( 1.0f );

	GLfloat c = .9;
	glColor3f( c, c, c );
	
	// make a line
	glBegin( GL_LINE_STRIP );
	GLfloat xpos = -g_xlim;
	GLfloat xinc = 2*g_xlim / (2*NUM_VIZ_SIDES + g_bufferFrames/2);
	
	for(int i = 0; i < (2*NUM_VIZ_SIDES + g_bufferFrames/2); i++)
	{
		glVertex3f( xpos, ypos + g_vis_buff[buf_num][i], zpos );
		xpos += xinc;
	}
	glEnd();	
	glPopMatrix();

}

//-----------------------------------------------------------------------------
// Name: drawPoly()
// Desc: callback from GLUT
//-----------------------------------------------------------------------------
void drawPoly(GLfloat ypos, int buf_num, GLfloat zpos)
{
	glPushMatrix();
	GLfloat c = 0.0;
	glColor3f( c, c, c );
	
	// make a series of polygons
	glBegin( GL_POLYGON );
	GLfloat xpos = -g_xlim;
	GLfloat xinc = 2*g_xlim / (2*NUM_VIZ_SIDES + g_bufferFrames/2);
	
	for(int i = 0; i < (2*NUM_VIZ_SIDES + g_bufferFrames/2 -1); i++)
	{
	
		glVertex3f( xpos, ypos -.2, zpos);		
		glVertex3f( xpos+xinc, ypos + g_vis_buff[buf_num][i], zpos );
		glVertex3f( xpos+xinc, ypos + g_vis_buff[buf_num][i+1], zpos );
		glVertex3f( xpos, ypos -.2, zpos);
		
		xpos += xinc;
	}
	glEnd();	
	glPopMatrix();

}



//-----------------------------------------------------------------------------
// Name: idleFunc( )
// Desc: callback from GLUT
//-----------------------------------------------------------------------------
void idleFunc( )
{
    // render the scene
    glutPostRedisplay( );
}


//-----------------------------------------------------------------------------
// Name: initialize( )
// Desc: sets initial OpenGL states
//       also initializes any application data
//-----------------------------------------------------------------------------
void initialize()
{
    // set the GL clear color - use when the color buffer is cleared
    glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );
    // set the shading model to 'smooth'
    glShadeModel( GL_SMOOTH );
    // enable depth
    glEnable( GL_DEPTH_TEST );
    // set the front faces of polygons
    glFrontFace( GL_CCW );
    // set fill mode
    glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
    
    // enable lighting
    glEnable( GL_LIGHTING );
    // enable lighting for front
    glLightModeli( GL_FRONT_AND_BACK, GL_TRUE );
    // material have diffuse and ambient lighting 
    glColorMaterial( GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE );
    // enable color
    glEnable( GL_COLOR_MATERIAL );
    
    // enable light 0
    glEnable( GL_LIGHT0 );
    
    // setup and enable light 1
    glLightfv( GL_LIGHT1, GL_AMBIENT, g_light1_ambient );
    glLightfv( GL_LIGHT1, GL_DIFFUSE, g_light1_diffuse );
    glLightfv( GL_LIGHT1, GL_SPECULAR, g_light1_specular );
    // glEnable( GL_LIGHT1 );
    
    // set the position of the lights
    glLightfv( GL_LIGHT0, GL_POSITION, g_light0_pos );
    // glLightfv( GL_LIGHT1, GL_POSITION, g_light1_pos );
    
    // seed random number generator
    srand( time(NULL) );
	
	// Set up RtAudio ===================
	
	if( rtA.getDeviceCount() < 1)
	{
		cout <<" No audio devices found!"<<endl;
		exit( 1 );
	}
	
	RtAudio::StreamParameters inParams, outParams;
	outParams.deviceId = rtA.getDefaultOutputDevice();
	outParams.nChannels = NUMCHANS;
	inParams.deviceId = rtA.getDefaultInputDevice();
	inParams.nChannels = NUMCHANS;
	unsigned int framesPerBuf = 512;
	
	// start audio
	try {
		rtA.openStream( &outParams, &inParams, RTAUDIO_FLOAT32, SAMPRATE, &framesPerBuf,
					   &audioGen, NULL);
		rtA.startStream();
	}
	catch ( RtError& e ) {
		e.printMessage();
		exit( 1 );
	}
	
	// allocate memory
	g_buffy = new SAMPLE[framesPerBuf];
    memset( g_buffy, 0, sizeof(SAMPLE)*framesPerBuf );
    assert( g_buffy != NULL );
	
	g_buffy_work = new SAMPLE[framesPerBuf];
    memset( g_buffy_work, 0, sizeof(SAMPLE)*framesPerBuf );
    assert( g_buffy_work != NULL );
	
	// allocate 2-d array for holding visuals
	g_vis_buff = (SAMPLE **)malloc(NUM_VIZ_BUFS * sizeof(SAMPLE *));
	if(g_vis_buff == NULL)
	{
		cerr << "out of memory!" << endl;
		exit(0);
	}
	for(int i = 0; i < NUM_VIZ_BUFS; i++)
	{
		g_vis_buff[i] = (SAMPLE *)malloc((framesPerBuf/2 + 2*NUM_VIZ_SIDES) * sizeof(SAMPLE));
		if(g_vis_buff[i] == NULL)
		{
			cerr << "out of memory!" << endl;
			exit(0);
		}
	}
	
    // remember the buffer frame
    g_bufferFrames = framesPerBuf;
	g_fft_size = framesPerBuf;
	
	// open audio files
	wav_info.samplerate = SAMPRATE;
	wav_info.channels = 2;
	wav_info.format = SF_FORMAT_WAV;
	wav_info.seekable = 1;
	sf_count_t sfc;
	
	// num1
	wav_info.frames = 170710;
	if(! (wavfp1 = sf_open("h2b-loop1-2br.wav", SFM_READ, &wav_info)))
	{	
		puts (sf_strerror (NULL));
	}	
	wav1 = new Wav_Buf(wav_info.frames, 2);
	sfc = sf_read_float(wavfp1, wav1->buffy, wav_info.frames*2) ;
	cerr<<"sfc3 = "<<sfc<<endl;	
	
	// num2
	wav_info2.samplerate = SAMPRATE;
	wav_info2.channels = 2;
	wav_info2.format = SF_FORMAT_WAV;
	wav_info2.seekable = 1;	
	wav_info2.frames = 341420;
	if(! (wavfp2 = sf_open("h2b-loop2-4br.wav", SFM_READ, &wav_info2))) 
	{	
		puts (sf_strerror (NULL));
	}
	wav2 = new Wav_Buf(wav_info2.frames, 2);
	sfc = sf_read_float(wavfp2, wav2->buffy, wav_info2.frames*2) ;
	cerr<<"file 2sfc = "<<sfc<<endl;
	
	// num3
	wav_info3.samplerate = SAMPRATE;
	wav_info3.channels = 2;
	wav_info3.format = SF_FORMAT_WAV;
	wav_info3.seekable = 1;	
	wav_info3.frames = 682839;
	if(!(wavfp3 = sf_open("h2b-loop3-8br.wav", SFM_READ, &wav_info3)))
	{	
		puts (sf_strerror (NULL));
	}	
	wav3 = new Wav_Buf(wav_info3.frames, 2);
	sfc = sf_read_float(wavfp3, wav3->buffy, wav_info3.frames*2) ;
	cerr<<"sfc 3 = "<<sfc<<endl;
	
	// num4
	wav_info.frames = 682839;
	wavfp4 = sf_open("h2b-loop4-8br.wav", SFM_READ, &wav_info) ;
	if(wavfp4 == NULL)
		cerr <<"Wav4 failed to open!"<<endl;
	wav4 = new Wav_Buf(wav_info.frames, 2);
	sfc = sf_read_float(wavfp4, wav4->buffy, wav_info.frames*2) ;
	cerr<<"sfc = "<<sfc<<endl;
	

	// allocate graphics objects
	left_edge = new Edge( g_left, g_bottom, g_left, g_top, s_left);
	right_edge = new Edge( g_right, g_bottom, g_right, g_top, s_right);
	bottom_edge = new Edge( g_left, g_bottom, g_right, g_bottom, s_bottom);
	top_edge = new Edge( g_left, g_top, g_right, g_top, s_top);
	
	top_edge->wbuf = wav1;
	bottom_edge->wbuf = wav2;
	left_edge->wbuf = wav3;
	right_edge->wbuf = wav4;
	
	puck = new Ball( g_puck_rad );
	paddle = new Ball( g_paddle_rad );
	puck->other_ball = paddle;
}

//-----------------------------------------------------------------------------
// Wav_Buf class functions
//-----------------------------------------------------------------------------
Wav_Buf::Wav_Buf(int num_frames, int num_chans)
{
	// FIXME: should do error checking!
	buffy = NULL;
	cerr<<"buffy="<<buffy<<endl;
	buffy = new SAMPLE[num_frames * num_chans];
	cerr<<"buffy="<<buffy<<endl;
	if(buffy == NULL)
		cerr<<"Error allocating sample data!";
    memset( buffy, 0, num_frames * num_chans*sizeof(SAMPLE) );
	
	read_ptr = 0;
	num_samps = num_frames * num_chans;
	states[0]=states[1]=states[2]=states[3]=false;
}

Wav_Buf::~Wav_Buf()
{
	delete buffy;
}

SAMPLE Wav_Buf::getNext(){
	SAMPLE temp;
	
	temp = buffy[read_ptr++];
	read_ptr = (read_ptr >= num_samps) ? 0 : read_ptr;
	return temp;
}

void Wav_Buf::setZero()
{
	read_ptr = 0;
}



//-----------------------------------------------------------------------------
// Name: keyboardFunc( )
// Desc: key event
//-----------------------------------------------------------------------------
void keyboardFunc( unsigned char key, int x, int y )
{
    switch( key )
    {
		case 'Q':
		case 'q':
			cleanUp();
			exit(1);
			break;
		case 'o':
		case 'O':
			g_outOnOff = !g_outOnOff;
			break;
		case 'p':
		case 'P':
			g_pause = !g_pause;
			break;
		case 'e':
		case 'E':
			g_extras = !g_extras;
			break;
    }
	
    glutPostRedisplay( );
}

//-----------------------------------------------------------------------------
// Name: cleanUp( )
// Desc: cleans up dynamic memory for vArray
//-----------------------------------------------------------------------------
void cleanUp( )
{
	// stop audio & cleanup
	try {
	 rtA.stopStream();
	 }
	 catch ( RtError& e ) {
	 e.printMessage();
	 }
	 
	 if( rtA.isStreamOpen() )
	 rtA.closeStream(); 
	
	// delete buffers
	delete g_buffy;
	delete g_buffy_work;
	delete g_vis_buff;
	
	sf_close(wavfp1);
	sf_close(wavfp2);
	sf_close(wavfp3);
	sf_close(wavfp4);
	
	delete wav1;
	delete wav2;
	delete wav3;
	delete wav4;

}

//-----------------------------------------------------------------------------
// name: next_power_2()
// desc: ...
// thanks: to Niklas Werner / music-dsp
//-----------------------------------------------------------------------------
unsigned long next_power_2( unsigned long n )
{
    unsigned long nn = n;
    for( ; n &= n-1; nn = n );
    return nn * 2;
}

//----------------------------------------------------------------------------
// printInputOptions:
//----------------------------------------------------------------------------
void printInputOptions()
{
	cout << endl << "------ control options ------" << endl;
	cout << "To turn audio output on/off type 'o'." <<endl;
	cout << "To pause the graphics type 'p'." <<endl;
	cout << "To add extras (zero crossings and extras) type 'e'." <<endl;
	cout << "To quit program type 'q'." <<endl;
}

//-----------------------------------------------------------------------------
// edge class functions
//-----------------------------------------------------------------------------

// CTOR
Edge::Edge(GLfloat ilx, GLfloat ily, GLfloat ihx, GLfloat ihy, side_t s)
{
	// inner edge lo and hi, x and y
	m_ilx = ilx;
	m_ily = ily;
	m_ihx = ihx;
	m_ihy = ihy;
	
	cerr<<"IL="<<m_ilx<<m_ily<<m_ihx<<m_ihy<<endl;

	m_side = s;
	
	state[0] = false;
	state[1] = false;
	state[2] = false;
	state[3] = false;	
	
	if ((m_side == s_left) || (m_side == s_right))
	{
		m_th1 = ily + (ihy - ily)/4.;
		m_th2 = ily + (ihy - ily)/2.;
		m_th3 = ily + 3.*(ihy - ily)/4.;
	}
	else
	{		
		m_th1 = ilx + (ihx - ilx)/4.;
		m_th2 = ilx + (ihx - ilx)/2.;
		m_th3 = ilx + 3.*(ihx - ilx)/4.;
		
		cerr<<"threshes ="<<m_th1<<" "<<m_th2<<" "<<m_th3<<endl;
	}
}

void Edge::draw()
{
	//cerr<<"draw"<<endl;
	
	glPushMatrix();
	glLineWidth( 1.3f );
	
	GLfloat c = .9;
	glColor3f( c, c, c );
	
	// draw rest of square and lattices
	if( m_side == s_left)
	{
		// filled boxes
		//glPushMatrix();
		//glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		if (state[0])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_ilx, m_ily, m_ilx-SIDE_WIDTH, m_th1);
		}
		if (state[1])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_ilx, m_th1, m_ilx-SIDE_WIDTH, m_th2);
		}
		if (state[2])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_ilx, m_th2, m_ilx-SIDE_WIDTH, m_th3);
		}
		if (state[3])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_ilx, m_th3, m_ilx-SIDE_WIDTH, m_ihy);
		}
		
		
		// draw square
		glColor3f( c, c, c );
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_ilx, m_ily);
		glVertex2f( m_ihx, m_ihy);
		glVertex2f( m_ihx - SIDE_WIDTH, m_ihy);
		glVertex2f( m_ilx - SIDE_WIDTH, m_ily);
		glVertex2f( m_ilx, m_ily);
		glEnd();
		
		// lattices
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_ihx, m_th1);
		glVertex2f( m_ihx - SIDE_WIDTH, m_th1);
		glEnd();
		
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_ihx, m_th2);
		glVertex2f( m_ihx - SIDE_WIDTH, m_th2);
		glEnd();
		
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_ihx, m_th3);
		glVertex2f( m_ihx - SIDE_WIDTH, m_th3);
		glEnd();
		
		
		
	}

	if( m_side == s_right)
	{
		if (state[0])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_ilx, m_ily, m_ilx+SIDE_WIDTH, m_th1);
		}
		if (state[1])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_ilx, m_th1, m_ilx+SIDE_WIDTH, m_th2);
		}
		if (state[2])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_ilx, m_th2, m_ilx+SIDE_WIDTH, m_th3);
		}
		if (state[3])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_ilx, m_th3, m_ilx+SIDE_WIDTH, m_ihy);
		}		
		
		// draw square
		glColor3f( c, c, c );glBegin( GL_LINE_STRIP );
		glVertex2f( m_ilx, m_ily);
		glVertex2f( m_ihx, m_ihy);glVertex2f( m_ihx + SIDE_WIDTH, m_ihy);
		glVertex2f( m_ilx + SIDE_WIDTH, m_ily);
		glVertex2f( m_ilx, m_ily);
		glEnd();
		
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_ihx, m_th1);
		glVertex2f( m_ihx + SIDE_WIDTH, m_th1);
		glEnd();
		
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_ihx, m_th2);
		glVertex2f( m_ihx + SIDE_WIDTH, m_th2);
		glEnd();
		
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_ihx, m_th3);
		glVertex2f( m_ihx + SIDE_WIDTH, m_th3);
		glEnd();
	}
	
	if( m_side == s_top)
	{
		if (state[0])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_ilx, m_ily, m_th1, m_ily+SIDE_WIDTH);
		}
		if (state[1])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_th1, m_ily, m_th2, m_ily + SIDE_WIDTH);
		}
		if (state[2])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_th2, m_ily, m_th3, m_ily + SIDE_WIDTH);
		}
		if (state[3])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_th3, m_ily, m_ihx, m_ily + SIDE_WIDTH);
		}
		
		// draw square
		glColor3f( c, c, c );glBegin( GL_LINE_STRIP );
		glVertex2f( m_ilx, m_ily);
		glVertex2f( m_ihx, m_ihy);glVertex2f( m_ihx, m_ihy+SIDE_WIDTH);
		glVertex2f( m_ilx, m_ihy+SIDE_WIDTH);
		glVertex2f( m_ilx, m_ily);
		glEnd();
		
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_th1, m_ihy);
		glVertex2f( m_th1, m_ihy + SIDE_WIDTH);
		glEnd();
		
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_th2, m_ihy);
		glVertex2f( m_th2, m_ihy + SIDE_WIDTH);
		glEnd();

		glBegin( GL_LINE_STRIP );
		glVertex2f( m_th3, m_ihy);
		glVertex2f( m_th3, m_ihy + SIDE_WIDTH);
		glEnd();
	}

	if( m_side == s_bottom)
	{
		if (state[0])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_ilx, m_ily, m_th1, m_ily-SIDE_WIDTH);
		}
		if (state[1])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_th1, m_ily, m_th2, m_ily-SIDE_WIDTH);
		}
		if (state[2])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_th2, m_ily, m_th3, m_ily-SIDE_WIDTH);
		}
		if (state[3])
		{
			glColor3f( 0.4, 0.1, 0.0 );
			glRectf( m_th3, m_ily, m_ihx, m_ihy-SIDE_WIDTH);
		}
		
		// draw square
		glColor3f( c, c, c );glBegin( GL_LINE_STRIP );
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_ilx, m_ily);
		glVertex2f( m_ihx, m_ihy);glVertex2f( m_ihx, m_ihy-SIDE_WIDTH);
		glVertex2f( m_ilx, m_ihy-SIDE_WIDTH);
		glVertex2f( m_ilx, m_ily);
		glEnd();
		
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_th1, m_ihy);
		glVertex2f( m_th1, m_ihy - SIDE_WIDTH);
		glEnd();
		
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_th2, m_ihy);
		glVertex2f( m_th2, m_ihy - SIDE_WIDTH);
		glEnd();
		
		glBegin( GL_LINE_STRIP );
		glVertex2f( m_th3, m_ihy);
		glVertex2f( m_th3, m_ihy - SIDE_WIDTH);
		glEnd();
	}

	glPopMatrix();
}

void Edge::bump(GLfloat cont_pt)
{
	//cerr<<"BUMP at"<<cont_pt<<endl;
	if (cont_pt > m_th3)
	{
		state[3] = !state[3];
		cerr<<"state3="<<state[3]<<endl;
		wbuf->states[3] = state[3];
	}
	else if (cont_pt > m_th2)
	{
		state[2] = !state[2];
		cerr<<"state2="<<state[2]<<endl;
		wbuf->states[2] = state[2];
	}
	else if (cont_pt > m_th1)
	{
		state[1] = !state[1];
		cerr<<"state1="<<state[1]<<endl;
		wbuf->states[1] = state[1];
	}
	else
	{
		state[0] = !state[0];
		cerr<<"state0="<<state[0]<<endl;
		wbuf->states[0] = state[0];
	}
}

//-----------------------------------------------------------------------------
// Ball class functions
//-----------------------------------------------------------------------------
Ball::Ball(GLfloat radius)
{
	m_rad = radius;
	
	m_xpos = g_left + (g_right - g_left) * rand() / (double)RAND_MAX;
	m_ypos = g_bottom + (g_top - g_bottom) * rand() / (double)RAND_MAX;;
		
//	m_xvel = 0.001 + 0.0005*rand() / (double)RAND_MAX;
//	m_yvel = 0.001 + 0.0005*rand() / (double)RAND_MAX;
	
	float r1,r2;
	r1 =rand() / (double)RAND_MAX;
	r2 =rand() / (double)RAND_MAX;
	
	m_xvel = (r1 > 0.5) ? g_init_vel : -g_init_vel;
	m_yvel = (r1 > 0.5) ? g_init_vel : -g_init_vel;
		
	//m_xvel = g_init_vel;
	//m_yvel = g_init_vel;
	
	cerr<<"init vels="<<m_xvel<<" "<<m_yvel<<endl;

	other_ball = NULL;
	
}

void Ball::draw()
{
	glPushMatrix();
	glLineWidth( 1.2f );
	
	GLfloat c = .9;
	glColor3f( c, c, c );
	
	// draw inner line
	glBegin( GL_LINE_STRIP );
	
	
	/* draw a solid disc from a bunch of triangles */
	GLfloat vectorY, vectorX;
	float angle;
	GLfloat vectorY1 = m_ypos;
	GLfloat vectorX1 = m_xpos;
		
	glBegin(GL_TRIANGLES);	
	for(int i=0;i<=360;i++)
	{
		angle=(float)(((double)i)/57.29577957795135);	
		vectorX = m_xpos + (m_rad * (float)sin((double)angle));
		vectorY = m_ypos + (m_rad * (float)cos((double)angle));		
		glVertex2d( m_xpos, m_ypos);
		glVertex2d(vectorX1,vectorY1);
		glVertex2d(vectorX,vectorY);
		vectorY1=vectorY;
		vectorX1=vectorX;	
	}
	glEnd();
	glPopMatrix();
}

void Ball::tick(float time_delta)
{
//	cerr<<"time delt = "<<time_delta<<endl;
	
	m_xpos += m_xvel * time_delta;
	m_ypos += m_yvel * time_delta;
	
	// edge detection
	if ((m_xpos-m_rad < g_left))
	{
		// hit left side
		m_xvel = -m_xvel;
		left_edge->bump(m_ypos);
	}
	else if ((m_xpos+m_rad > g_right))
	{
		// hit right side
		m_xvel = -m_xvel;
		right_edge->bump(m_ypos);		
	}
	else if ((m_ypos+m_rad > g_top))
	{
		// hit top side
		m_yvel = -m_yvel;
		top_edge->bump(m_xpos);
	}
	else if ((m_ypos-m_rad < g_bottom))
	{
		// hit bottom side
		m_yvel = -m_yvel;
		bottom_edge->bump(m_xpos);
	}
	
	// detect colision with other ball
	if (other_ball != NULL)
	{
		//
		GLfloat dist = sqrt( pow(m_xpos - other_ball->m_xpos,2.) + pow(m_ypos - other_ball->m_ypos,2.));
		GLfloat r3 = m_rad + other_ball->m_rad;
		if (dist < r3 )
		{
			cerr<<"COLLISION!!!"<<endl;
			float r1,r2;
			r1 =rand() / (double)RAND_MAX;
			r2 =rand() / (double)RAND_MAX;
			cerr<<"R1, R2="<<r1<<" "<<r2<<endl;
			
			m_xvel = r1*m_xvel;
			m_yvel = r2*m_yvel;
		}

	}
}








