/*
 *  Zhong.h
 *  
 *
 *  Created by luke on 12/7/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

// a way to prevent circular includes
#ifndef __ZHONG_H__
#define __ZHONG_H__



#define SIDE_WIDTH 0.07
// defines
//#define SAMPLE double
#define SAMPLE float
#define SAMPRATE 44100
// #define	PI 3.14159265358979
#define NUMCHANS 2
#define OUT_LEVEL 0.3
//#define NUM_VIZ_BUFS 60
#define NUM_VIZ_BUFS 30
#define NUM_VIZ_SIDES 125



//-----------------------------------------------------------------------------
// Globals 
//-----------------------------------------------------------------------------

// width and height of the window, sides of field
GLsizei g_width = 700;
GLsizei g_height = 450;
GLfloat g_left = -1.6;
GLfloat g_right = 1.6;
GLfloat g_top = 1.7;
GLfloat g_bottom = -1.1;
GLfloat g_puck_rad = 0.04;
GLfloat g_paddle_rad = 0.12;

double	g_last_time = 0.0;
GLfloat g_init_vel = 2.1;

enum side_t {
	s_left,
	s_right,
	s_top,
	s_bottom
};	




//-----------------------------------------------------------------------------
// Ball class
//-----------------------------------------------------------------------------

class Ball
{		
public:
	GLfloat m_xpos;
	GLfloat m_ypos;
	GLfloat m_rad;
	
	GLfloat m_xvel;		// units per second
	GLfloat m_yvel;
	Ball * other_ball;

	Ball(GLfloat radius);
	void tick(float time_delta);
	void draw();
		
};

//-----------------------------------------------------------------------------
// Audio_Buff class
//-----------------------------------------------------------------------------
class Wav_Buf
{
public:
	SAMPLE * buffy;
	//SAMPLE * read_ptr;
	int read_ptr;
	unsigned long num_samps;
	SAMPLE getNext();
	void   setZero();
	bool states[4];
	Wav_Buf(int num_samps, int num_chans);
	~Wav_Buf();
};
	
	
//-----------------------------------------------------------------------------
// Edge class
//-----------------------------------------------------------------------------

class Edge
	{
		// coordinates of the inner border of edge box
		GLfloat m_ilx;
		GLfloat m_ily;
		GLfloat m_ihx;
		GLfloat m_ihy;
		
		// threshold locations for segments
		GLfloat m_th1;
		GLfloat m_th2;
		GLfloat m_th3;
		
		side_t m_side;
		
		// 4 colors
		
		// on off states
		bool state[4];
		
	public:
		// edge();
		Edge(GLfloat il, GLfloat ih, GLfloat ol, GLfloat oh, side_t s);
		// ~edge();
		void bump(GLfloat cont_pt);
		void draw();
		Wav_Buf * wbuf;
	};


	
		



#endif